import numpy as np
import tensorflow as tf
from tensorflow.keras.layers import Input, Conv2D
from tensorflow.keras.models import Model
import cv2

sample_inp = cv2.imread('lena.jpg',cv2.IMREAD_GRAYSCALE)
sample_out = np.loadtxt('lena-sobel.txt', dtype=np.float32)
rows,cols = sample_inp.shape
sample_inp = np.array(sample_inp).reshape((rows,cols,1))
sample_out = np.array(sample_out).reshape((rows,cols,1))
sample_inp.shape
sample_out.shape
samples_inp = np.array([sample_inp],np.float32)
samples_out = np.array([sample_out],np.float32)

inp = Input(shape=(None,None,1))
out = Conv2D(1, (3, 3), kernel_initializer='normal', use_bias=False, padding='same')(inp)
model = Model(inputs=inp, outputs=out)
model.summary()

model.compile(optimizer='rmsprop', loss='mse', metrics=['mse', 'mae'])

model.fit(samples_inp, samples_out, batch_size=1, epochs = 15000)

model.layers[1].get_weights()

model.evaluate(samples_inp, samples_out, verbose=True)
model.metrics_names

output_images = model.predict(samples_inp)

output_image = output_images[0].reshape((rows,cols))

output_image = np.abs(output_image);
output_image = cv2.normalize(output_image,None,0,255,cv2.NORM_MINMAX)
output_image = np.uint8(output_image)
cv2.imwrite('lena-approx-sobel.jpg',output_image)

cv2.imshow('lena',output_image)
cv2.waitKey(0)
cv2.destroyWindow('lena')

model.save('sobel.h5')

#quit()
