import numpy as np
import tensorflow as tf
from tensorflow.keras.layers import Input, Conv2D
from tensorflow.keras.models import Model
from tensorflow.keras.models import load_model
import cv2

model = load_model('sobel.h5')

image = cv2.imread('lena.jpg',cv2.IMREAD_GRAYSCALE)
rows,cols = image.shape
input_image = np.array(image).reshape((rows,cols,1))
input_images = np.array([input_image],np.float32)

output_images = model.predict(input_images)

output_image = output_images[0].reshape((rows,cols))
output_image = np.abs(output_image);
output_image = cv2.normalize(output_image,None,0,255,cv2.NORM_MINMAX)
output_image = np.uint8(output_image)
cv2.imshow('lena',output_image)
cv2.waitKey(0)
cv2.destroyWindow('lena')

#quit()
